diff -crN buildroot-2013.08.1-ckb-20140807-1/board/ckb/common/uart_flasher/target/ckb-3352/device.c buildroot-2013.08.1-ckb-20141129-1/board/ckb/common/uart_flasher/target/ckb-3352/device.c
*** buildroot-2013.08.1-ckb-20140807-1/board/ckb/common/uart_flasher/target/ckb-3352/device.c	2013-12-20 10:02:20.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/board/ckb/common/uart_flasher/target/ckb-3352/device.c	2014-11-28 09:00:44.000000000 +0900
***************
*** 200,208 ****
--- 200,210 ----
  
  /* MAIN PLL Fdll = 1 GHZ, */
  #define MPUPLL_M_275	 275	/* 125 * n */
+ #define MPUPLL_M_300	 300	/* 125 * n */
  #define MPUPLL_M_500	 500	/* 125 * n */
  #define MPUPLL_M_600	 600	/* 125 * n */
  #define MPUPLL_M_720	 720	/* 125 * n */
+ #define MPUPLL_M_800	 800	/* 125 * n */
  
  #define MPUPLL_N		 23	/* (n -1 ) */
  #define MPUPLL_M2		 1
***************
*** 252,257 ****
--- 254,260 ----
  #define DEFDCDC3			0x10
  #define DEFSLEW				0x11
  #define DCDC_GO				0x80
+ #define V0950				0x02
  #define V1100				0x08
  #define V1200				0x0C
  #define V1275				0x0F
***************
*** 569,574 ****
--- 572,580 ----
  #define vrefp			(PAD_CTRL_BASE + 0x330)
  #define vrefn			(PAD_CTRL_BASE + 0x334)
  
+ /* TI81XX spefic control submodules */
+ #define DEVICE_ID_REG_OFFSET		0x600
+ #define DEVICE_ID_REG	(CTRL_BASE + DEVICE_ID_REG_OFFSET)
  
  /* I2C */
  #define I2C_BASE1		0x44E0B000
***************
*** 1258,1265 ****
  	int DDR3_EMIF_TIM3				= 0x501F830F;		// by calc_tool
  	int DDR3_EMIF_SDREF				= 0x0000093B;		// 303MHz * 7.8us
  	int DDR3_ZQ_CFG					= 0x50074BE4;
! 	//int DDR3_EMIF_SDCFG				= 0x61C04AB2;
! 
  	int reg_sdram_type;
  	int reg_ibank_pos;
  	int reg_ddr_term;
--- 1264,1270 ----
  	int DDR3_EMIF_TIM3				= 0x501F830F;		// by calc_tool
  	int DDR3_EMIF_SDREF				= 0x0000093B;		// 303MHz * 7.8us
  	int DDR3_ZQ_CFG					= 0x50074BE4;
! 	
  	int reg_sdram_type;
  	int reg_ibank_pos;
  	int reg_ddr_term;
***************
*** 1307,1313 ****
  	reg_ebank				= (0<<3);
  	reg_pagesize			= (2);			/* 10 1k */
  
- //	Outport(3, EMIF4_0_SDRAM_CONFIG,			DDR3_EMIF_SDCFG);
  	Outport(3, EMIF4_0_SDRAM_CONFIG,	reg_sdram_type		|
                                          reg_ibank_pos		|
                                          reg_ddr_term		|
--- 1312,1317 ----
***************
*** 1326,1334 ****
  }
  
  
! void pll_init()
  {
! 	mpu_pll_config(MPUPLL_M_500);
  	core_pll_config();
  	per_pll_config();
  	ddr_pll_config();
--- 1330,1341 ----
  }
  
  
! void pll_init(int revision)
  {
! 	if(revision >= AM335X_REV_ES2_0)
! 		mpu_pll_config(MPUPLL_M_600);
! 	else
! 		mpu_pll_config(MPUPLL_M_500);
  	core_pll_config();
  	per_pll_config();
  	ddr_pll_config();
***************
*** 1824,1861 ****
  int tps65217_reg_write(int prot_level, int dest_reg, int dest_val, int mask)
  {
  
! 		int read_val;
! 		int xor_reg;
  
! 		/* if we are affecting only a bit field, read dest_reg and apply the mask */
! 		if (mask != MASK_ALL_BITS) {
! 			if (i2c_read_byte(TPS65217_CHIP_PM, dest_reg, &read_val))
! 				return 1;
! 			read_val &= (~mask);
! 			read_val |= (dest_val & mask);
! 			dest_val = read_val;
! 		}
! 
! 		if (prot_level > 0) {
! 			xor_reg = dest_reg ^ PASSWORD_UNLOCK;
! 			if (i2c_write_byte(TPS65217_CHIP_PM, PASSWORD, xor_reg))
! 				return 1;
! 		}
  
! 		if (i2c_write_byte(TPS65217_CHIP_PM, dest_reg, dest_val))
  			return 1;
  
! 		if (prot_level == PROT_LEVEL_2) {
! 			if (i2c_write_byte(TPS65217_CHIP_PM, PASSWORD, xor_reg))
! 				return 1;
  
! 			if (i2c_write_byte(TPS65217_CHIP_PM, dest_reg, dest_val))
! 				return 1;
! 		}
  
! 		return 0;
  }
  
  void arm_275m()
  {
  	int mask1	= 0x3F;
--- 1831,1868 ----
  int tps65217_reg_write(int prot_level, int dest_reg, int dest_val, int mask)
  {
  
! 	int read_val;
! 	int xor_reg;
  
! 	/* if we are affecting only a bit field, read dest_reg and apply the mask */
! 	if (mask != MASK_ALL_BITS) {
! 		if (i2c_read_byte(TPS65217_CHIP_PM, dest_reg, &read_val))
! 			return 1;
! 		read_val &= (~mask);
! 		read_val |= (dest_val & mask);
! 		dest_val = read_val;
! 	}
  
! 	if (prot_level > 0) {
! 		xor_reg = dest_reg ^ PASSWORD_UNLOCK;
! 		if (i2c_write_byte(TPS65217_CHIP_PM, PASSWORD, xor_reg))
  			return 1;
+ 	}
  
! 	if (i2c_write_byte(TPS65217_CHIP_PM, dest_reg, dest_val))
! 		return 1;
  
! 	if (prot_level == PROT_LEVEL_2) {
! 		if (i2c_write_byte(TPS65217_CHIP_PM, PASSWORD, xor_reg))
! 			return 1;
  
! 		if (i2c_write_byte(TPS65217_CHIP_PM, dest_reg, dest_val))
! 			return 1;
! 	}
! 	return 0;
  }
  
+ // Rev ES1
  void arm_275m()
  {
  	int mask1	= 0x3F;
***************
*** 1868,1873 ****
--- 1875,1897 ----
  	mpu_pll_config(MPUPLL_M_275);
  
  }
+ 
+ // Rev >= ES2_0
+ void arm_300m()
+ {
+ 	int mask1	= 0x3F;
+ 	int mask2	= 0x80;;
+ 
+ 	i2c_init(100000,1);
+ 	//tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1100,mask1);
+ 	tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V0950,mask1);
+ 	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
+ 	udelay(1);
+ 	mpu_pll_config(MPUPLL_M_300);
+ 
+ }
+ 
+ // Rev ES1
  void arm_500m()
  {
  	int mask1	= 0x3F;
***************
*** 1881,1916 ****
  
  }
  
! void arm_600m()
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
  
  	i2c_init(100000,1);
! 	tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1200,mask1);
  	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
  	udelay(1);
  	mpu_pll_config(MPUPLL_M_600);
  
  }
  
! void arm_720m()
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
  
  	i2c_init(100000,1);
! 	tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1275,mask1);
  	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
  	udelay(1);
  	mpu_pll_config(MPUPLL_M_720);
  
  }
  
! void init_DEVICE()
  {
  	watchdog_init();
! 	pll_init();
  	
  	pin_config();
  	gpmc_config();
--- 1905,1986 ----
  
  }
  
! void arm_600m(int revision)
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
  
  	i2c_init(100000,1);
! 	if(revision >= AM335X_REV_ES2_0)
! 		tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1100,mask1);
! 	else
! 		tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1200,mask1);
  	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
  	udelay(1);
  	mpu_pll_config(MPUPLL_M_600);
  
  }
  
! void arm_720m(int revision)
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
  
  	i2c_init(100000,1);
! 	if(revision >= AM335X_REV_ES2_0)
! 		tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1200,mask1);
! 	else
! 		tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1275,mask1);
  	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
  	udelay(1);
  	mpu_pll_config(MPUPLL_M_720);
  
  }
+ // Rev >= ES2_0
+ void arm_800m()
+ {
+ 	int mask1	= 0x3F;
+ 	int mask2	= 0x80;;
+ 
+ 	i2c_init(100000,1);
+ 	tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1275,mask1);
+ 	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
+ 	udelay(1);
+ 	mpu_pll_config(MPUPLL_M_800);
+ 
+ }
  
! unsigned long get_dev_id()
  {
+ 	return Inport(3, DEVICE_ID_REG);
+ }
+ 
+ int init_DEVICE()
+ {
+ 	int revision;
+ 	unsigned long idcode;
+ 	unsigned char rev;
+ 
  	watchdog_init();
! 	/* get the CPU revision */
! 	idcode = get_dev_id();
! 	rev = (idcode >> 28) & 0xff;
! 	switch(rev)
! 	{
! 	case 0:
! 		revision = AM335X_REV_ES1_0;
! 		break;
! 	case 1:
! 		revision = AM335X_REV_ES2_0;
! 		break;
! 	case 2:
! 		revision = AM335X_REV_ES2_1;
! 		break;
! 	default:
! 		revision = AM335X_REV_UNKNOWN;
! 		break;
! 	}
! 	pll_init(revision);
  	
  	pin_config();
  	gpmc_config();
***************
*** 1918,1925 ****
  	config_am335x_ddr3();
  	/* some problem with CS1 mode, use GPIO mode */
  	gpmc_cs1_ext_cn_config(1);			/* 1 -> GPIO mode, 0->CS1 mode */
! 	//arm_600m();
  	DEVICE_UARTInit(115200);
  }
  
  void set_nor_flash_bank(int bank)
--- 1988,1999 ----
  	config_am335x_ddr3();
  	/* some problem with CS1 mode, use GPIO mode */
  	gpmc_cs1_ext_cn_config(1);			/* 1 -> GPIO mode, 0->CS1 mode */
! 	if(revision >= AM335X_REV_ES2_0)
! 		arm_800m();
! 	else
! 		arm_720m(revision);
  	DEVICE_UARTInit(115200);
+ 	return revision;
  }
  
  void set_nor_flash_bank(int bank)
diff -crN buildroot-2013.08.1-ckb-20140807-1/board/ckb/common/uart_flasher/target/ckb-3352/include/device.h buildroot-2013.08.1-ckb-20141129-1/board/ckb/common/uart_flasher/target/ckb-3352/include/device.h
*** buildroot-2013.08.1-ckb-20140807-1/board/ckb/common/uart_flasher/target/ckb-3352/include/device.h	2013-12-20 10:02:20.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/board/ckb/common/uart_flasher/target/ckb-3352/include/device.h	2014-11-28 09:00:05.000000000 +0900
***************
*** 15,20 ****
--- 15,27 ----
  #endif
  
  #define TARGET_NAME	"CKB-3352 (COMPUTEX Kumikomi Board)"
+ // CPU Revision
+ enum {
+ 	AM335X_REV_ES1_0,
+ 	AM335X_REV_ES2_0,
+ 	AM335X_REV_ES2_1,
+ 	AM335X_REV_UNKNOWN
+ };
  
  // System Control Module register structure
  typedef struct _DEVICE_SYS_MODULE_REGS_
***************
*** 510,516 ****
  #define dlm ier
  #define LSR lsr
  
- 
  /* useful defaults for LCR */
  #define UART_LCR_8N1	0x03
  
--- 517,522 ----
***************
*** 518,524 ****
  #define UART_CLK_RUNNING_MASK	0x1
  #define UART_SMART_IDLE_EN	(0x1 << 0x3)
  
- 
  /*
   * These are the definitions for the FIFO Control Register
   */
--- 524,529 ----
***************
*** 606,612 ****
  * Global Function Declarations                             *
  ***********************************************************/
  // System Initialization prototypes
! extern void  init_DEVICE(void);
  
  /***********************************************************
  * End file                                                 *
--- 611,617 ----
  * Global Function Declarations                             *
  ***********************************************************/
  // System Initialization prototypes
! extern int init_DEVICE(void);
  
  /***********************************************************
  * End file                                                 *
diff -crN buildroot-2013.08.1-ckb-20140807-1/fs/Config.in buildroot-2013.08.1-ckb-20141129-1/fs/Config.in
*** buildroot-2013.08.1-ckb-20140807-1/fs/Config.in	2014-01-24 09:50:56.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/fs/Config.in	2014-11-27 16:38:49.000000000 +0900
***************
*** 22,28 ****
  
  config BR2_CUSTOM_ROOT_DIR_NAME
  	string "Create a rootfs under"
! 	default "target_without_usr"
  	depends on BR2_EXCLUDE_USR_DIR_FROM_ROOTFS
  	help
  	  The name of the folder under which the rootfs excluding the
--- 22,28 ----
  
  config BR2_CUSTOM_ROOT_DIR_NAME
  	string "Create a rootfs under"
! 	default "intrd"
  	depends on BR2_EXCLUDE_USR_DIR_FROM_ROOTFS
  	help
  	  The name of the folder under which the rootfs excluding the
***************
*** 31,42 ****
  
  config BR2_CUSTOM_USR_DIR_NAME
  	string "Move contents of /usr to"
! 	default "sdcard_usr_folder"
  	depends on BR2_EXCLUDE_USR_DIR_FROM_ROOTFS
  	help
  	  The name of the folder into which the contents of /usr will
  	  be moved. This directory will appear under the
! 	  "output\images\" folder.
  
  config BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT
  	string "Run this script after excluding contents of /usr"
--- 31,49 ----
  
  config BR2_CUSTOM_USR_DIR_NAME
  	string "Move contents of /usr to"
! 	default "microSD"
  	depends on BR2_EXCLUDE_USR_DIR_FROM_ROOTFS
  	help
  	  The name of the folder into which the contents of /usr will
  	  be moved. This directory will appear under the
! 	  "output\" folder.
! 
! config BR2_USR_DIR_OVERLAY_NAME
! 	string "/usr overlay directories"
! 	default ""
! 	depends on BR2_EXCLUDE_USR_DIR_FROM_ROOTFS
! 	help
! 	  Specify a list of directories that are copied over the /usr directory.
  
  config BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT
  	string "Run this script after excluding contents of /usr"
diff -crN buildroot-2013.08.1-ckb-20140807-1/fs/common.mk buildroot-2013.08.1-ckb-20141129-1/fs/common.mk
*** buildroot-2013.08.1-ckb-20140807-1/fs/common.mk	2014-04-03 09:36:11.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/fs/common.mk	2014-11-27 16:38:59.000000000 +0900
***************
*** 39,44 ****
--- 39,45 ----
  
  CUSTOM_USR_DIR_NAME:=$(call qstrip,$(BR2_CUSTOM_USR_DIR_NAME))
  CUSTOM_ROOT_DIR_NAME:=$(call qstrip,$(BR2_CUSTOM_ROOT_DIR_NAME))
+ USR_DIR_OVERLAY_NAME:=$(call qstrip,$(BR2_USR_DIR_OVERLAY_NAME))
  EXCLUDE_USR_DIR-clean=./exclude_usr_dir-clean
  
  check_exclude_usr_dir:
***************
*** 58,74 ****
  	cp -rd $(TARGET_DIR)/ $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)
  	touch $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)/THIS_IS_NOT_YOUR_ROOT_FILESYSTEM
  	rm -rf $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)/THIS_IS_NOT_YOUR_ROOT_FILESYSTEM
! 	touch $(BINARIES_DIR)/$(CUSTOM_USR_DIR_NAME)
! 	rm -rf $(BINARIES_DIR)/$(CUSTOM_USR_DIR_NAME)
! 	mkdir $(BINARIES_DIR)/$(CUSTOM_USR_DIR_NAME)
! 	@$(call MESSAGE,"Moving \"usr\" folder to $(BINARIES_DIR)/$(CUSTOM_USR_DIR_NAME)/")
! 	mv $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)/usr/* $(BINARIES_DIR)/$(CUSTOM_USR_DIR_NAME)
  	@if ! [ $(BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT)11 == ""11 ]; then \
  		$(call MESSAGE,"Executing custom script $(BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT)") ;\
  		chmod +x $(BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT) ;\
  		$(BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT) $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME) $(BINARIES_DIR)/$(CUSTOM_USR_DIR_NAME) ;\
! 	fi ;\
! 	echo "chown -R 0:0 $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)" >> $(FAKEROOT_SCRIPT) ;\
  
  exclude_usr_dir-clean:
  	@if ! [ $(CUSTOM_ROOT_DIR_NAME)11 = 11 ]; then \
--- 59,79 ----
  	cp -rd $(TARGET_DIR)/ $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)
  	touch $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)/THIS_IS_NOT_YOUR_ROOT_FILESYSTEM
  	rm -rf $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)/THIS_IS_NOT_YOUR_ROOT_FILESYSTEM
! 	touch $(BASE_DIR)/$(CUSTOM_USR_DIR_NAME)
! 	rm -rf $(BASE_DIR)/$(CUSTOM_USR_DIR_NAME)
! 	mkdir -p $(BASE_DIR)/$(CUSTOM_USR_DIR_NAME)/usr/
! 	@$(call MESSAGE,"Moving contents of \"usr\" folder to $(BASE_DIR)/$(CUSTOM_USR_DIR_NAME)/usr/")
! 	mv $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)/usr/* $(BASE_DIR)/$(CUSTOM_USR_DIR_NAME)/usr/
! 	@if ! [ $(BR2_USR_DIR_OVERLAY_NAME)11 == ""11 ]; then \
! 		$(call MESSAGE,"Copying contents of $(BR2_USR_DIR_OVERLAY_NAME) to $(BASE_DIR)/$(CUSTOM_USR_DIR_NAME)/usr/") ;\
! 		cp -rd $(USR_DIR_OVERLAY_NAME)/* $(BASE_DIR)/$(CUSTOM_USR_DIR_NAME)/usr/ ;\
! 	fi ;
  	@if ! [ $(BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT)11 == ""11 ]; then \
  		$(call MESSAGE,"Executing custom script $(BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT)") ;\
  		chmod +x $(BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT) ;\
  		$(BR2_EXCLUDE_USR_DIR_POST_BUILD_SCRIPT) $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME) $(BINARIES_DIR)/$(CUSTOM_USR_DIR_NAME) ;\
! 	fi ;
! 	echo "chown -R 0:0 $(BASE_DIR)/$(CUSTOM_ROOT_DIR_NAME)" >> $(FAKEROOT_SCRIPT) ;
  
  exclude_usr_dir-clean:
  	@if ! [ $(CUSTOM_ROOT_DIR_NAME)11 = 11 ]; then \
diff -crN buildroot-2013.08.1-ckb-20140807-1/linux/linux.mk buildroot-2013.08.1-ckb-20141129-1/linux/linux.mk
*** buildroot-2013.08.1-ckb-20140807-1/linux/linux.mk	2014-07-08 16:05:59.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/linux/linux.mk	2014-11-25 16:26:37.000000000 +0900
***************
*** 348,355 ****
  		$(SED) "/\\<CONFIG_CKB_LCD_02\\>/d" $(@D)/.config; \
  		echo "# CONFIG_CKB_LCD_02 is not set" >> $(@D)/.config; \
  		\
! 		$(SED) "/\\<CONFIG_CKB_EXTCN_SPIDEV_SPI1\\>/d" $(@D)/.config; \
! 		echo "# CONFIG_CKB_EXTCN_SPIDEV_SPI1 is not set" >> $(@D)/.config; \
  		\
  		$(SED) "/\\<CONFIG_CKB_3352_AUDIO\\>/d" $(@D)/.config; \
  		echo "# CONFIG_CKB_3352_AUDIO is not set" >> $(@D)/.config; \
--- 348,355 ----
  		$(SED) "/\\<CONFIG_CKB_LCD_02\\>/d" $(@D)/.config; \
  		echo "# CONFIG_CKB_LCD_02 is not set" >> $(@D)/.config; \
  		\
! 		$(SED) "/\\<CONFIG_CKB_EXTCN_6_31_36_38\\>/d" $(@D)/.config; \
! 		echo "# CONFIG_CKB_EXTCN_6_31_36_38 is not set" >> $(@D)/.config; \
  		\
  		$(SED) "/\\<CONFIG_CKB_3352_AUDIO\\>/d" $(@D)/.config; \
  		echo "# CONFIG_CKB_3352_AUDIO is not set" >> $(@D)/.config; \
